//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2
#property indicator_level1  0
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern double EmaPeriod = 14;
extern int    Price     = PRICE_CLOSE;
extern string StartFrom = "09:00"; 
extern string EndAt     = "17:30"; 

//
//
//
//
//

double ema[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,ema);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
    
      double alpha = 2.0 /(1.0+EmaPeriod);
      for(int i = limit; i>=0; i--)
      {
         string   today = TimeToStr(Time[i],TIME_DATE);
         datetime tfrom = StrToTime(today+" "+StartFrom);
         datetime tto   = StrToTime(today+" "+EndAt);
            if (Time[i]>=tfrom && Time[i]<tto)
                  ema[i] = ema[i+1]+alpha*(iMA(NULL,0,1,0,MODE_SMA,Price,i)-ema[i+1]);
            else  ema[i] = ema[i+1];
      }            
   return(0);
}